{ config, lib, pkgs, ... }:

let
  unstable = import <nixos-unstable> {};
in {

  environment.systemPackages = with pkgs; [
    gnumake
    go
    rustup
    unstable.golangci-lint
    unstable.gopls
    unstable.rust-analyzer

    (python38.withPackages(python-packages: with python-packages; [
      pyls-black
      pyls-isort
      pyls-mypy
      python-language-server
      pyyaml
      requests
    ]))

    emacs
    ltrace
    sops
    tig

    openssl pkg-config nasm cmake zlib gcc binutils-unwrapped
  ];
}
